//--------------------------- Who Are You? --------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//--------------------------------------------------------------
//
//  Suggested HTML Input:
/*
   <APPLET code="WhoAreU.class" align="baseline" width="500" height="200">

        <CENTER><FONT SIZE=3>{If you can read this, your browser 
        dosen`t support Java.}</FONT><BR>
        <FONT FACE="Helvetica" COLOR="#FF0000" SIZE=7>Welcome  
        anyway, mystery visitor.</FONT></CENTER><BR>
    </APPLET>
*/
//
//--------------------------------------------------------------

import java.applet.Applet;
import java.awt.*;
import java.net.*;

public class WhoAreU extends Applet {

    String      myStrAddy,   myStrAddy2,   myStrAddy3;
    InetAddress myAddress,   myAddress2,   myAddress3;
    int         iTemp;
    Dimension   d;
    FontMetrics fm;
    Panel       setupNorth,  setupMiddle;
    GridBagLayout       GBL1;
    GridBagConstraints  GBC1;
    String      Title;
    Color       C1;
    
//  ------------------------------------------------------------

    public void init(){

        setBackground(Color.white);
        setForeground(Color.black);

        setLayout(new BorderLayout(5,5));
        setupNorth  = new Panel();
        setupMiddle = new Panel();

        setupNorth.setFont(new Font("Times Roman",Font.BOLD,28));
        GBL1       = new GridBagLayout();
        GBC1       = new GridBagConstraints();


        GBC1.gridwidth  = 1;
        GBC1.gridheight = 1;
        GBC1.gridx      = 0;
        GBC1.gridy      = 0;
        GBC1.insets.top = 15;
        GBC1.anchor     = GridBagConstraints.CENTER;
        setupNorth.setLayout(GBL1);
        Title           = new String("Welcome Visitor");
        setupNorth.add(new Label(Title));
        add("North", setupNorth);

        getAddys();
        setMiddle(GBC1, GBL1, setupMiddle);
        add("Center", setupMiddle);

    }

    //  --------------------------------------------------------

    public void getAddys() {
        try{
                // getLocalHost returns an Inet address
            myAddress   = InetAddress.getLocalHost();

                // Convert Inet address to string
            myStrAddy   = myAddress.toString();
//          System.out.println(myStrAddy);

                // Returns a String of the host name from addy
            myStrAddy2  = myAddress.getHostName(); 
//          System.out.println("LocalHost Name = "+myStrAddy2);

                // Return a String of portion of addy after "/"
            iTemp       = myStrAddy.indexOf('/');
            myStrAddy3  = myStrAddy.substring(iTemp + 1);
//          System.out.println("IP Address = "+myStrAddy3);

                // Returns Byte Vector representation of IP address
                // Note: bytes are signed so have to convert
            byte[] Vect = myAddress.getAddress();
            System.out.println("Byte Vector: ");
            for(int Cnt = 0; Cnt < Vect.length; Cnt++){
                int unSgnVect = Vect[Cnt] < 0 ? Vect[Cnt] + 256 : Vect[Cnt];
                System.out.print(unSgnVect + "-");
            }

        } catch(UnknownHostException e){
            System.out.println(e);
        }
    }

    //  --------------------------------------------------------

    public void setMiddle(GridBagConstraints gc, GridBagLayout gl, Panel p) {

        int          Xpt, Ypt, StrL0;
        String       Str;
        int          fH;

        gc.gridwidth     = 1;
        gc.gridheight    = 1;
        gc.gridx         = 0;
        gc.gridy         = 0;
        gc.insets.top    = 15;
        gc.insets.bottom = 5;
        gc.anchor        = GridBagConstraints.CENTER;

        p.setForeground(Color.blue);
        p.setFont(new Font("Times Roman",Font.PLAIN,18));
        Label L0 = new Label(myStrAddy);
        gl.setConstraints(L0, gc);
        p.add(L0);

        gc.gridwidth     = GridBagConstraints.REMAINDER;
        p.setForeground(Color.black);
        p.setFont(new Font("Times Roman",Font.PLAIN,18));
        L0 = new Label("Or should I say,");
        gl.setConstraints(L0, gc);
        p.add(L0);

        gc.gridwidth     = GridBagConstraints.REMAINDER;
        p.setForeground(Color.blue);
        p.setFont(new Font("Times Roman",Font.PLAIN,18));
        L0 = new Label(myStrAddy2);
        gl.setConstraints(L0, gc);
        p.add(L0);

        gc.gridwidth     = GridBagConstraints.REMAINDER;
        p.setForeground(Color.black);
        p.setFont(new Font("Times Roman",Font.PLAIN,18));
        L0 = new Label("Or for all you Mr. Spocks,");
        gl.setConstraints(L0, gc);
        p.add(L0);

        gc.gridwidth     = GridBagConstraints.REMAINDER;
        p.setForeground(Color.blue);
        p.setFont(new Font("Times Roman",Font.PLAIN,18));
        L0 = new Label(myStrAddy3);
        gl.setConstraints(L0, gc);
        p.add(L0);

    }

//  ------------------------------------------------------------

}

//  ============================================================
